diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/stateManager/smiobjectset.hxx smixx/src/stateManager/smiobjectset.hxx
--- smixx_web/src/stateManager/smiobjectset.hxx	2005-08-09 17:57:46.000000000 +0200
+++ smixx/src/stateManager/smiobjectset.hxx	2007-03-19 10:24:16.000000000 +0100
@@ -26,7 +26,7 @@
 
 		SMIObjectSet(const SMIObjectSet& );
 		
-		SMIObjectSet& SMIObjectSet::operator=(const SMIObjectSet& );
+		SMIObjectSet& operator=(const SMIObjectSet& );
 
 		Name name() const;
 
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/stateManager/state.cxx smixx/src/stateManager/state.cxx
--- smixx_web/src/stateManager/state.cxx	2005-08-09 17:57:48.000000000 +0200
+++ smixx/src/stateManager/state.cxx	2007-03-19 09:55:42.000000000 +0100
@@ -65,7 +65,7 @@
     }
 
 
-   char action_nm[MAXNAMESIZE];
+   Name action_nm;
 
    int no_aclines;
 
@@ -223,7 +223,7 @@
 
 //------------------------------- execute  (for Logical objects) ------------
 
-int State::execute( const Name& actionstr, char* pnewState) const {
+int State::execute( const Name& actionstr, Name& endState ) const {
 //
 //  cout << " state : " << _stateName << " to execute action |" 
 //                              << pname_act << "|\n \n";
@@ -239,10 +239,10 @@
 	pAction = static_cast<Action*>(_actions.gimePointer(i));
 
         if ( action == actionnm ) {
-            int temp = pAction->execute(pnewState,actionstr);
+            int temp = pAction->execute(endState,actionstr);
             if ( temp == 0 ) {  // This means that the last action instruction
 //                           is not terminate_action instruction
-               _stateName.whatAreYou(pnewState,256);
+               endState =_stateName;
                return 1;
             }
             return temp;
@@ -267,8 +267,6 @@
 
   if ( !actionExists(actionnm) ) { return -1; }  
 
-  char actionstr_out[256];
-
   Parms inpars;
   inpars.initFromParmString(actionstr);
 
@@ -303,9 +301,8 @@
   inpars.buildParmString(parmstr);
   temp = actionnm;
   temp += parmstr;
-  temp.whatAreYou(actionstr_out,256);    
 
-  pCommHandler->sendCommand(_objName.getString(),actionstr_out);
+  pCommHandler->sendCommand(_objName.getString(),temp.getString());
   return 1;
 
 }
@@ -403,14 +400,6 @@
 
 }
 
-
-void State::action ( const int index, char* action ) const {
-
-        _actions.gimeName(index).whatAreYou(action,MAXNAMESIZE);
-
-	return;
-
-}
 //----------------------------- actionString ----------------------------------
 //   action/par1/par2=555/par3
 //
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/stateManager/state.hxx smixx/src/stateManager/state.hxx
--- smixx_web/src/stateManager/state.hxx	2005-08-09 17:57:48.000000000 +0200
+++ smixx/src/stateManager/state.hxx	2005-09-30 16:58:47.000000000 +0200
@@ -29,7 +29,7 @@
 
   void whatAreYou() const;
 //
-  int execute( const Name& actionstr,char* pnewState) const;
+  int execute( const Name& actionstr, Name& endState) const;
 //
   int execute_assoc
       ( const Name& actionstr, const CommHandler* const pCommHandler) const;
@@ -56,8 +56,6 @@
 
   void action( const int index, Action** pAction) const;
 
-  void action( const int index, char* action) const;
-
   void actionString( const int index, char* actionstr, const int maxsize) const;
 
   Name actionString( const int index ) const;
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/stateManager/state_manager.cxx smixx/src/stateManager/state_manager.cxx
--- smixx_web/src/stateManager/state_manager.cxx	2005-08-09 17:57:48.000000000 +0200
+++ smixx/src/stateManager/state_manager.cxx	2006-03-31 15:59:30.000000000 +0200
@@ -92,14 +92,20 @@
 
 
 // ****************************
-/*
+/*  debug
    cout << "\n \n  The following objects are registered : \n \n";
 
   int numOfObjects;
   numOfObjects = allSMIObjects.numOfObjects();
 
   for (int io=0; io < numOfObjects; io++) {
-     cout << allSMIObjects.gimeName(io) << "\n";
+     SMIObject* ptnr = allSMIObjects.gimePointer(io);
+     bool isAssoc = ptnr->associated();
+     bool hasAssocAtt = ptnr->hasAssociatedAttribute();
+     cout << allSMIObjects.gimeName(io) << "  " << isAssoc << "  " 
+     << hasAssocAtt << endl;
+     if ( isAssoc != hasAssocAtt ) { cout << "********************************" <<
+     endl;}
   }
 */
 //************************************************************************
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/stateManager/termins.cxx smixx/src/stateManager/termins.cxx
--- smixx_web/src/stateManager/termins.cxx	2004-11-11 14:40:56.000000000 +0100
+++ smixx/src/stateManager/termins.cxx	2005-09-28 18:41:09.000000000 +0200
@@ -28,8 +28,8 @@
 
    _pParentAction = pAction;
 
-   sscanf(lines[0],"%s",_endState);
-//   cout <<  " state : |" << _endState << "| \n";
+   _endState = lines[0];
+//   cout <<  " state : " << _endState << " \n";
 
    no_lines = 1;
    return;
@@ -45,7 +45,7 @@
 
 //-------------------------------  execute  -----------------------------------
 
-int TermIns::execute(char* pendState){
+int TermIns::execute( Name& endState ){
 
    if ( _pParentObject->name() == "&ALLOC" ) {
 
@@ -83,12 +83,12 @@
          if ( idPresent ) {
             valid.replace(doubleq,nullstr);   // get rid of the double quotes
             ptgState->changeName(valid);
-            valid.whatAreYou(pendState,256);
+            endState = valid;
          }
          else {
             valAmpersId.replace(doubleq,nullstr);   // get rid of the double quotes
             ptgState->changeName(valAmpersId);
-            valAmpersId.whatAreYou(pendState,256);
+            endState = valAmpersId;
          }
          valAmpersId.replace(doubleq,nullstr);   // get rid of the double quotes
          allocator = valAmpersId;
@@ -96,18 +96,18 @@
          pCommHandlerGl->domainAllocated(intConnId);
       }
       else {  // this must be RELEASE action
-         strcpy(pendState,_endState);
+         endState = _endState;
          allocator = "\0";
 
          pCommHandlerGl->domainDeallocated(intConnId);
       }
    }
    else {
-       strcpy(pendState,_endState);  
+       endState = _endState; 
    }
 
 #ifdef DEBUG
-cout   << "  terminate_action / state=" << pendState << "\n";
+cout   << "  terminate_action / state=" << endState << "\n";
 cout.flush();
 #endif
 
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/stateManager/termins.hxx smixx/src/stateManager/termins.hxx
--- smixx_web/src/stateManager/termins.hxx	2001-05-16 09:13:28.000000000 +0200
+++ smixx/src/stateManager/termins.hxx	2005-09-28 18:41:09.000000000 +0200
@@ -10,18 +10,20 @@
 
 #include "parameters.hxx"
 #include "instruction.hxx"
+#include "name.hxx"
 class SMIObject;
 class State;
 class Action;
 
+
 class TermIns : public Instruction {
 public:
   TermIns( char lines[][MAXRECL], const int lev, 
            SMIObject* pObj, State* pState, Action* pAction, int& no_lines);
   void whatAreYou();
-  int execute(char *pstate);   // 0-normal,  1-terminated action, 2-suspended
+  int execute( Name& endState );   // 0-normal,  1-terminated action, 2-suspended
 private:
-  char _endState[MAXNAMESIZE];
+  Name _endState;
   int _level;
 
   SMIObject* _pParentObject;
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/tclTkGUI/History smixx/src/tclTkGUI/History
--- smixx_web/src/tclTkGUI/History	1970-01-01 01:00:00.000000000 +0100
+++ smixx/src/tclTkGUI/History	2007-03-19 09:55:42.000000000 +0100
@@ -0,0 +1,135 @@
+ History File for generic SMI GUI using tcl/Tk
+---------------------------------------------------------------------------
+21-Mar-2006 (Boda Franek)
+ This is not even the first version. It is just a bunch of usefull code
+ which I 'hacked' during the last Christmas and that will serve as a good start.
+============================  tclTkGUI-v00 ====================================
+=== 31-March-2006:17:27 ==========  v30  =================
+=== 19-May-2006:20:34 ==========  v31  =================
+=== 21-May-2006:21:01 ==========  v31r1  =================
+19-Jan-2007 (Boda Franek)
+ This is the first usable version of the GUI
+============================  tclTkGUI-v01  ==================================
+
+ 25-Jan-2007
+ 
+ 1) objectParPanel_create.tcl ...
+ 	a) procedure 'objectParHeadingPanel_create' removed, as it creates just
+	   one label and the label creation was put directly into
+	   procedure 'objectParInfoPanel'
+	   
+	b) procedure 'objectParInfoPanel' now takes an extra argument 'title'
+	
+	c) new procedure 'objectParPanel_display' that displays the panel as
+	   a top level window.
+	   
+ 2) objectParPanel_create.tcl
+        procedure 'objectParPanel_create' and  'objectParPanel_display'
+	take extra argument 'title'
+	
+ 3) main.tcl
+     procedure paramPanel_display modified in such a way, that it is possible
+     to display parameter panel either as a part of object window, or as
+     a toplevel window.This is achieved by a simple switch. It is left so that
+     panels are displayed as toplevels.
+==============================  tclTkGUI-v02 ===================================
+ 26-Jan-2007 (Boda Franek)
+ 
+   - new file canvasObjects.tcl ... suite of procedures for managing objects
+        on canvas
+	
+   - main.tcl  & and  actionParPanel_display.tcl ... quick hack to display
+       objects on canvas rather than as independent windows
+       
+ it appears reasonably functional --> tag
+=============================  tclTkGUI-v03  ===================================
+ 31-Jan-2007 (Boda Franek)
+ 
+    Added some baloon help. Files affected : 
+           canvasObjects.tcl, main.tcl, mainPanel.tcl
+	   
+================================================================================
+ 5-Feb-2007 (Boda Franek)
+ 
+   - new files  A.gif, P.gif and X.gif  containing small letter A,P and X to be
+      used on some object buttons.
+      
+   - topbar.tcl ... taking font from options
+   
+   - parametersGroups.tcl ... 
+   	a) making sure, that entry widget turns white once it receives input
+	
+	b) lining up parameters on the display on the right
+	
+   - main.tcl ...
+   	a) adding some options
+	b) creating images from the new gif files..see above
+	
+   - canvasObjects.tcl ... 'pasting' the new images on 'action', 'parameters' 
+        and remove buttons
+	
+   - mainPanel.tcl ... allowing the GUI Logo to adjust itself
+=============================  tclTkGUI-v04  ===================================
+=============================  tclTkGUI-v05  ===================================
+ 5-Feb-2007 (Boda Franek)
+ 
+            State Colors (file main.tcl & canvasObjects.tcl)
+	    -----------
+  - These are defined in the array stateColor('object name')
+  
+  - some defaults are defined  in main.tcl
+
+  - state DEAD and &DEAD are special cases 
+=============================  tclTkGUI-v06  ===================================  
+13-Feb-2007 (Boda Franek)
+
+    New, integrated way to browse for objects which also allows changing their
+    --------------------------------------------------------------------------
+    order.
+    -----
+    
+    - new file objectSelectionPanel.tcl containing the necessary software
+
+    - new file Scrolled_Listbox.tcl containing generic code for scrollable lists
+      picked up from B.B.Welch book
+      
+    - the above uses the 3 new gif files for its buttons : 
+         downArrow.gif, upArrow.gif and rightArrow.gif  
+    
+    - main.tcl  sourcing the new software
+    
+    - mainPanel.tcl new procedure 'browseForObjects' using the new software
+    
+    - canvasObjects.tcl fixed a minor bug
+=============================  tclTkGUI-v07  ===================================
+    - mainPanel.tcl ... obsolete procedures 'findAndAddObjects' and 'getDomains'
+                       removed
+		       
+    - main.tcl ... adjusting options
+    
+    
+    - objectSelectionPanel.tcl  ...  warning messages made childern of the 
+              corresponding widget. This preserves correct stacking order
+=============================  tclTkGUI-v08  ===================================	      
+   16-Feb-2007 (Boda Franek)
+   
+    - Allowing to save and retrieve object configuration
+      --------------------------------------------------
+        necessary changes to mainPanel.tcl, topbar.tcl
+	
+    - objectSelectionPanel.tcl ... objects deleted on click of 3rd mouse button
+            rather than 2nd
+	    
+    - parameterGroups.tcl  ... no value represented by zero length string
+ =============================  tclTkGUI-v09  ===================================
+   18-Feb-2007  (Boda Franek)
+   
+   - listBox_create.tcl  changed format from DOS to Unix
+   
+   - canvasObjects.tcl ... bug fixed in  'proc updateObjectOnCanvas'
+            before a state of an object is updated, check is made wheather
+	    the object is displayed
+	    
+   - objectSelectionPanel.tcl ... option '-activestyle' taken out, because older
+            versions of Tcl/Tk do not support it
+	    
Binary files smixx_web/src/tclTkGUI/P.gif and smixx/src/tclTkGUI/P.gif differ
Binary files smixx_web/src/tclTkGUI/SMIXXLogo.gif and smixx/src/tclTkGUI/SMIXXLogo.gif differ
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/tclTkGUI/actionParPanel_display.tcl smixx/src/tclTkGUI/actionParPanel_display.tcl
--- smixx_web/src/tclTkGUI/actionParPanel_display.tcl	1970-01-01 01:00:00.000000000 +0100
+++ smixx/src/tclTkGUI/actionParPanel_display.tcl	2007-03-19 09:55:42.000000000 +0100
@@ -0,0 +1,153 @@
+#====================================================================
+#
+#                           Boda Franek    Dec 2005
+# Copyright Information:
+#       Copyright (C) 2005 CCLRC. All Rights Reserved
+#
+#  $Id: actionParPanel_display.tcl,v 1.10 2007/01/26 14:34:44 franek Exp $
+#====================================================================
+#===============================================================================
+proc actionParPanel_display {object action parameters} {
+# The panel is modal and has 3 sections :
+#  1 - Heading
+#  2 - parameters
+#  3 - controls  OK and Cancel buttons
+#===============================================================================
+	global objectId
+	global actionParPanelid actionParPanelidAnswer
+	global actionParPanelAction actionParPanelObject
+    
+	if { [info exists actionParPanelid] } {
+		bell
+		wm deiconify $actionParPanelid
+		raise $actionParPanelid
+		update idletasks
+		return
+	}
+    
+	set actionParPanelAction $action
+	set actionParPanelObject $object
+
+# create the Panel 
+	set actionParPanelid [dialog_create "Action Parameters"]
+    
+# get the window path for the information part of the dialog   
+	set info [dialog_info $actionParPanelid]
+
+# position it in the right place relative to the parent window
+#	set parentWin $objectId($object)
+        set parentWin .
+	set parentPosX [winfo rootx $parentWin]
+	set parentPosY [winfo rooty $parentWin]
+	
+	set x [expr $parentPosX+20]
+	set y [expr $parentPosY+20]
+    
+    puts stdout "Placing $actionParPanelid  at x $x  y $y"
+	wm geometry $actionParPanelid "+$x+$y"  
+	
+	set infoOnlyId [actionParInfoPanel $info.settings $object $action $parameters]
+	pack $infoOnlyId
+
+    set cntls [dialog_controls $actionParPanelid]
+    
+	button $cntls.ok -text ok -command { set actionParPanelidAnswer 1}
+	pack $cntls.ok -side left -expand yes
+
+    button $cntls.cancel -text Cancel -command { set actionParPanelidAnswer 0}
+    pack $cntls.cancel -side left -expand yes
+
+    focus $cntls.ok
+
+    wm protocol $actionParPanelid WM_DELETE_WINDOW "$cntls.cancel invoke"
+
+	dialog_wait $actionParPanelid actionParPanelidAnswer
+	
+	if { $actionParPanelidAnswer == "1" } {
+		actionParPanelOK
+	}
+	actionParPanel_destroy
+
+    return 
+}
+#===========================================================================
+proc actionParPanel_destroy {} {
+    global actionParPanelid
+
+    destroy $actionParPanelid
+    unset actionParPanelid
+
+    ParameterGroups::group_delete 1
+    return
+}
+#===========================================================================
+proc actionParHeadingPanel_create {win object action} {
+
+	frame $win        
+        	label $win.title -text "object: $object  action: $action" \
+			-relief flat
+        	pack $win.title
+	return $win
+}
+#===========================================================================
+proc actionParOnlyPanel_create {win parameters} {
+
+	frame $win
+	        actionParameterGroup_setup $parameters
+
+        	ParameterGroups::panel_create $win.parameters  1
+        	pack $win.parameters
+	return $win
+}
+#===========================================================================
+proc actionParInfoPanel  {win object action parameters}	{
+	
+	frame $win
+		set head [actionParHeadingPanel_create $win.head $object $action]
+		set parOnly [actionParOnlyPanel_create $win.par $parameters]
+		
+		pack $head
+	        
+		frame $win.sep -height 2 -borderwidth 1 -relief sunken
+        	pack $win.sep -fill x -pady 4
+		
+		pack $parOnly
+	return $win
+}		
+#==============================================================================
+proc actionParPanelOK {} {
+    global actionParPanelid actionParPanelidAnswer
+    global actionParPanelObject actionParPanelAction
+
+    if { [ParameterGroups::allValExists 1] == "0" } {
+        tk_messageBox -message "All parameters have to have values assigned"
+        return
+    }
+
+    set parameters [ ParameterGroups::getGroupParValues 1]
+
+    dispatchAction $actionParPanelObject $actionParPanelAction $parameters
+
+    return
+
+}
+#===================================================================================
+
+#======================================================================
+proc actionParameterGroup_setup {parameters} {
+
+    foreach parm $parameters {	
+	set name [lindex $parm 0]
+	set type [lindex $parm 1]
+	set def [lindex $parm 2]
+	if { $def == "" } {
+		set def &noval
+	}	
+        
+#tk_messageBox -message " $name $def $type "
+        set id [string tolower $name]    
+
+         ParameterGroups::parameter_create 1 $id $name $type -1
+         ParameterGroups::parameter_set 1 $id $def
+    }
+}   
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/tclTkGUI/assemble smixx/src/tclTkGUI/assemble
--- smixx_web/src/tclTkGUI/assemble	1970-01-01 01:00:00.000000000 +0100
+++ smixx/src/tclTkGUI/assemble	2006-12-06 11:42:14.000000000 +0100
@@ -0,0 +1,16 @@
+#! /bin/tcsh -f
+# takes as input a file containing source statements and assembles
+# all the sourced code on stdout
+#
+set FILE = ${1}
+set GUIdir = ${2}
+set efftcldir = ${3}
+
+foreach item (`cat $FILE`)
+	if ( $item == "source" ) then
+		continue
+	endif
+	eval cat $item
+end
+
+exit
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/tclTkGUI/canvasObjects.tcl smixx/src/tclTkGUI/canvasObjects.tcl
--- smixx_web/src/tclTkGUI/canvasObjects.tcl	1970-01-01 01:00:00.000000000 +0100
+++ smixx/src/tclTkGUI/canvasObjects.tcl	2007-02-18 09:23:22.000000000 +0100
@@ -0,0 +1,166 @@
+#=========================================================================
+proc getObjectId {object} {
+	set objId [string tolower $object]
+
+	set inx [string first :: $objId]
+	set inx1 [expr $inx+1]
+	set objId [string replace $objId $inx $inx1 /]
+
+
+	set inx [string first :: $objId]
+	if { $inx == "-1" } {
+		return $objId
+	}
+	set inx1 [expr $inx+1]
+	set objId [string replace $objId $inx $inx1 /]
+	return $objId
+}
+#=========================================================================
+proc updateObjectOnCanvas {win object state} {
+	global stateColor objectsOnCanvas
+
+	if { [ lsearch $objectsOnCanvas $object ] == "-1" } {
+	# the object is not displayed
+		return
+	}
+	
+        set body $win.canvas.frame       
+
+	set obId [getObjectId $object]
+        $body.state$obId configure -text $state
+	
+	if { [info exists stateColor($state)] } {
+		$body.state$obId configure -bg $stateColor($state)
+	} else {
+		$body.state$obId configure -bg white
+	}
+	
+	if { $state == "DEAD" || $state == "&DEAD" } {
+		$body.state$obId configure -bg black -fg white
+	}	
+	return
+} 
+#=========================================================================
+proc removeObjectFromCanvas {win object} {
+	global objectsOnCanvas
+	
+	set canvas $win.canvas
+        set body $win.canvas.frame
+	set obId [getObjectId $object]
+
+	destroy $body.menubut$obId $body.domain$obId $body.object$obId \
+		$body.state$obId $body.actions$obId $body.parameters$obId
+
+	set inx [lsearch $objectsOnCanvas $object]
+	set objectsOnCanvas [lreplace $objectsOnCanvas $inx $inx]
+        
+	update
+	set botpos [winfo height $body]
+	set rightpos [winfo width $body]
+	$canvas configure -scrollregion "0 0 $rightpos $botpos"        
+
+	return
+}	
+#=========================================================================
+proc addObjectToCanvas {win object} {
+	global imA imP imX
+	global objectsOnCanvas
+
+	if { [info exists objectsOnCanvas] } {
+		set inx [lsearch $objectsOnCanvas $object]
+		if { $inx != "-1" } {
+		# object is already there
+			bell
+			return
+		}
+	}
+	lappend objectsOnCanvas $object
+
+	set inx [string first :: $object]
+	set domain [string range $object 0 [expr $inx-1] ]
+	set objectNm [string range $object [expr $inx+2] end ]
+	
+	set canvas $win.canvas
+        set body $win.canvas.frame
+        
+	set lineNo [lrange [grid size $body] 1 1]
+	set obId [getObjectId $object]
+	
+	if { [lsearch [font names] hel1font] == -1 } {	
+		font create hel1font -family helvetica -size 2
+	}
+
+	menubutton $body.menubut$obId -image $imX  \
+                   -menu $body.menubut$obId.m -font hel1font -background white
+	menu $body.menubut$obId.m
+	$body.menubut$obId.m add command \
+		 -label "Remove Object" -command [list removeObjectFromCanvas $win $object]
+	grid $body.menubut$obId -row $lineNo -padx 5 -pady 0 -column 5
+
+        label $body.domain$obId -text $domain \
+                                -background white -relief flat -font helbold12font
+        grid $body.domain$obId -row $lineNo -padx 10 -pady  0 -column 2 -sticky w
+        
+        label $body.object$obId -text $objectNm  \
+		-background white -relief flat -font helbold12font
+        grid $body.object$obId -row $lineNo -padx 10 -column 3 -sticky w
+        
+        label $body.state$obId -text state \
+		-background white -relief groove -font helbold12font
+        grid $body.state$obId -row $lineNo -padx 10 -column 4 -sticky w
+
+
+        menubutton $body.actions$obId -image $imA  \
+	     -menu $body.actions$obId.menu \
+	     -background white -font hel1font
+	menu $body.actions$obId.menu -postcommand [list actionMenu_update $body.actions$obId.menu $object]
+        grid  $body.actions$obId -row $lineNo -padx 2 -column 0
+        
+        button $body.parameters$obId -image $imP \
+	     -command [list paramPanel_display $object] \
+	     -background white -font hel1font
+        grid  $body.parameters$obId -row $lineNo -padx 1 -column 1
+
+	balloonhelp_for $body.actions$obId "click to display available actions"
+	balloonhelp_for $body.parameters$obId "click to display object parameters"
+	balloonhelp_for $body.menubut$obId "Remove object from display"
+        
+	update
+	set botpos [winfo height $body]
+	set rightpos [winfo width $body]
+	$canvas configure -scrollregion "0 0 $rightpos $botpos"        
+        return
+}
+#=============================================================================
+proc objectPanel_create {win} {
+	frame $win
+
+		set height 200
+		set width  400
+		set borderwidth 2
+
+		set hscroll $win.hscroll
+		set vscroll $win.vscroll
+		set canvas $win.canvas
+
+		scrollbar $hscroll -orient horiz -command "$canvas xview"
+		scrollbar $vscroll               -command "$canvas yview"
+		canvas $canvas -relief sunken -borderwidth $borderwidth \
+                              -width $width -height $height \
+			      -background white \
+                              -xscrollcommand "$hscroll set" \
+                              -yscrollcommand "$vscroll set"
+        	# Ensure that window resizings retain scroll bars.
+		pack $hscroll -side bottom -fill x 
+		pack $vscroll -side right  -fill y
+		pack $canvas -fill both -expand yes
+
+		frame $canvas.frame
+       			$canvas create window 0 0 \
+			       -window $canvas.frame -anchor nw 
+			       
+		$canvas.frame configure -background white
+
+	set objectsOnCanvas {}
+	return $win
+}
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/tclTkGUI/convertHEXtoEASCII.tcl smixx/src/tclTkGUI/convertHEXtoEASCII.tcl
--- smixx_web/src/tclTkGUI/convertHEXtoEASCII.tcl	1970-01-01 01:00:00.000000000 +0100
+++ smixx/src/tclTkGUI/convertHEXtoEASCII.tcl	2006-11-19 17:26:23.000000000 +0100
@@ -0,0 +1,133 @@
+#==============================================================================
+#
+#                                  Boda Franek    November 2006
+# Copyright Information:
+#      Copyright (C) 2005 CCLRC.   All Rights Reserved
+#
+#    $Id: convertHEXtoEASCII.tcl,v 1.2 2006/11/19 16:26:23 franek Exp $
+#==============================================================================
+proc convertHEXtoEASCII {instring} {
+#=====================================================================
+#   every pair of characters in the 'instring' (starting with character 0
+#   and chacter 1 will be interpreted as a HEX number representing
+#    an ASCII character. This will be converted to the correspondig ASCII
+#   character if printable. If non-printable, \x will be pre-pended
+#   to the pair. An exception is '\'. This will be converted to '\\'
+#=====================================================================
+	set strlen [string length $instring]
+	set outstring ""
+
+	for {set i 0} {$i<$strlen} {incr i 2} {
+		set i1 [expr $i+1]
+		if { $i1 >= $strlen } {
+			bgerror "the input string has odd number of characters"
+			return ""
+		}
+		set a [string range $instring $i $i1]
+#		puts stdout " $a"
+		set ahex "0x$a"
+		
+		if { [catch {format "%c" $ahex} b] } {
+			bgerror $b
+			return ""
+		}
+
+		if { $b == "\\" } {
+			append outstring "\\\\"
+			continue
+		} 
+				
+		if { $b == " " } {
+			append outstring $b
+			continue
+		}
+				
+		if { [string is graph $b] } {
+			append outstring $b
+			continue
+		}
+		
+		if { $b == "\a" } {
+			append outstring "\\" a
+		} elseif { $b == "\b" } {
+			append outstring "\\" b
+		} elseif { $b == "\t" } {
+			append outstring "\\" t
+		} elseif { $b == "\n" } {
+			append outstring "\\" n
+		} elseif { $b == "\v" } {
+			append outstring "\\" v
+		} elseif { $b == "\f" } {
+			append outstring "\\" f
+		} elseif { $b == "\r" } {
+			append outstring "\\" r
+		} else {
+			append outstring "\\x"
+			append outstring $a
+		}
+	}
+	
+	return $outstring
+}
+#===========================================================================
+proc convertEASCIItoHEX {instring} {
+#==========================================================================
+#  Input string should consist only of printable characters or
+# escape sequences. An escape sequence begins with \ and is followed either
+# by another \ or by x and 2 hex digits representing character.
+#==========================================================================
+	set strlen [string length $instring]
+	set outstring ""
+	
+	for {set i 0} {$i<$strlen} {incr i} {
+		set ch [string range $instring $i $i]
+		if { $ch == "\\" } {
+			set specials "\\abtnvfr"
+			set i1 [expr $i+1]	
+			set ch1 [string range $instring $i1 $i1]
+			if { [string first $ch1 $specials] >= 0 } {
+				if { $ch1 == "\\" } {
+					binary scan "\\" "H2" bout					
+				} elseif { $ch1 == "a" } {
+					binary scan "\a" "H2" bout
+				} elseif { $ch1 == "b" } {
+					binary scan "\b" "H2" bout
+				} elseif { $ch1 == "t" } {
+					binary scan "\t" "H2" bout
+				} elseif { $ch1 == "n" } {
+					binary scan "\n" "H2" bout
+				} elseif { $ch1 == "v" } {
+					binary scan "\v" "H2" bout
+				} elseif { $ch1 == "f" } {
+					binary scan "\f" "H2" bout
+				} elseif { $ch1 == "r" } {
+					binary scan "\r" "H2" bout
+				}
+				append outstring $bout
+				incr i 
+				continue
+			} 
+
+			if { $ch1 == "x" || $ch1 == "X" } {
+				set i2 [expr $i1+1]
+				set i3 [expr $i2+1]
+				if { $i3 >= $strlen } {
+					bgerror " Illegal escape sequence\n"
+					return ""
+				}
+				append outstring [string range $instring $i2 $i3]
+				incr i 3
+				continue
+			} else {
+				bgerror " Illegal escape sequence\n"
+				return ""
+			}
+		} else {
+			binary scan $ch "H2" bout
+			append outstring $bout
+		}
+				
+	}
+	
+	return $outstring
+}
